/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung. Es werden damit nur bestimmte
Spezialfälle geprüft. Liefern die Testklassen keinen Fehler, garantiert dies noch nicht die
Korrektheit Ihrer Lösung gemäß der Angabe.
*/

public class Aufgabe2 {

    /*
    Aufgabe:
        Objekte der Klasse Tree stellen binäre Suchbäume über ganzen Zahlen mit Knoten vom Typ Node dar.
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 20):
        8 Punkte für toString,
        12 Punkte für sumLevel.

        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    // Just for testing (geht nicht in die Beurteilung ein).
    public static void main(String[] args) {
        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        System.out.println(tree.sumLevel(0)); // 5
        System.out.println(tree.sumLevel(1)); // 9
        System.out.println(tree.sumLevel(2)); // 15

        System.out.println(tree); // [1,2,5,6,7,8]
        System.out.println();

        Tree myTree = new Tree();
        System.out.println(myTree); //[]
    }

}

class Node {

    // Ändern Sie diese Variablen nicht. Deklarieren Sie keine weiteren Objekt-/globalen Variablen.
    int elem;
    Node left;
    Node right;

    // Ändern Sie den Konstruktor nicht.
    Node(int elem) {
        this.elem = elem;
    }

    // Ändern Sie diese Methode nicht.
    void add(int elem) {
        if (elem < this.elem) {
            if (left == null) {
                left = new Node(elem);
            } else {
                left.add(elem);
            }
        } else {
            if (right == null) {
                right = new Node(elem);
            } else {
                right.add(elem);
            }
        }
    }


    Integer sumLevel(int level) {
        if (level < 0) return 0;
        if (level == 0) return elem;

        int sum = 0;

        if (left != null) sum += left.sumLevel(level - 1);
        if (right != null) sum += right.sumLevel(level - 1);
        return sum;
    }

    int height() {
        int height = 0;

        if (left != null) height = left.height();
        if (right != null) {
            int rightHeight = right.height();
            if (rightHeight > height) height = rightHeight;
        }

        return height + 1;
    }

    @Override
    public String toString() {
        String output = "";

        if (right != null) output += right.toString();
        output += "," + elem;
        if (left != null) output += left.toString();

        return output;
    }
} // Ende der Definition von Node

class Tree {

    // Die Wurzel des Baums. Deklarieren Sie keine weiteren Objekt-/globalen Variablen.
    private Node root;

    // Fügt dem Baum 'elem' hinzu, wenn es noch nicht enthalten ist.
    // Ändern Sie diese Methode nicht.
    public void add(int elem) {
        if (root == null) {
            root = new Node(elem);
        } else {
            root.add(elem);
        }
    }

    // Liefert die Summe aller Elemente in eine bestimmten Ebene des Baums 't'.
    // Beispiel: Wenn 't' wie folgt aussieht:
    //         5
    //        / \
    //       2   7
    //      /   / \
    //     1   6   8
    // liefert 't.sumLevel(0)' den Wert 5
    // und 't.sumLevel(1)' den Wert 9
    // und 't.sumLevel(2)' den Wert 15
    // und 't.sumLevel(3)' den Wert 0.
    // Bei einem leeren Baum oder wenn der Baum in 'level' keine Elemente hat, wird 0 geliefert.
    // Annahme: level >= 0
    public int sumLevel(int level) {
        if (root == null) return 0;
        if (level >= root.height()) return 0;

        return root.sumLevel(level);
    }

    // Liefert eine Komma getrennte Liste der Elemente in absteigender Reihenfolge
    // mit umschliessenden eckigen Klammern.
    // Beispiel: Wenn der Baum die Elemente 1, 2, 3 und 4 enthält,
    // liefert die Methode "[1,2,3,4]" (unabhängig
    // von der Struktur des Baums).  Bei einem leeren Baum wird "[]" geliefert.
    @Override
    public String toString() {
        return root == null ? "[]" : "[" + root.toString().replaceFirst(",", "") + "]";
    }
}


